library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_signed.all;



entity datapath is
	port ( dato: in std_logic_vector(7 downto 0);
	       op: in std_logic_vector(1 downto 0);
		   clk, en_d0,en_d1,en_op: in std_logic;
		   ris: out std_logic_vector(7 downto 0));
end datapath;

architecture beh of datapath is

signal d0,d1: std_logic_vector(7 downto 0);
signal oper: std_logic_vector( 1 downto 0);

begin
	process(clk)
	begin
		if clk'event and clk='0' then
			if en_d0= '1' then  d0<= dato;
				                oper <= op;
			end if;
			if en_d1 = '1' then d1 <= dato;
			end if;
			if en_op = '1' then
				case oper is
					when "00" => --add
					             ris <= d0+d1;
					when "01" => -- sub
								ris <= d0-d1;
				when "10" => --and
				ris <= d0 and d1;
				when "11" => -- or;
				ris <= d0 or d1;
				when others => null;
				end case;
		 end if;
	 end if;
	end process;
end beh;

			
